| <?xml version='1.0' encoding='utf-8'?>
| <!DOCTYPE rfc SYSTEM "rfc2629-xhtml.ent">

// processing instructions
<?rfc toc="yes"?>
<?rfc symrefs="yes"?>
<?rfc compact="yes"?>
<?rfc subcompact="no"?>
<?rfc strict="no"?>
<?rfc rfcedstyle="yes"?>
<?rfc comments="yes"?>
<?rfc inline="yes"?>

mixin utf
	u(format="char")
		block

// categories: std | bcp | info | exp | historic
rfc(category='std' consensus='false' ipr='trust200902' docName='at30tse75xa-driver-01' submissionType='be-cem-mro' xml:lang='en' version='3')
	front
		title(abbrev="AT30TSE75XA Linux driver") Atmel AT30TSE752A, AT30TSE754A, AT30TSE758A I2C Linux driver
		author(fullname='Mathieu Donze' initials='M.D.' role='editor' surname='Donze')
			organization CERN
			address
				postal
					street 1, Esplanade des Particules
					code 1217
					city Meyrin
					country Switzerland
				email mathieu.donze@cern.ch
		date(year='2019' month="July" day="5")

		keyword AT30TSE75XA
		keyword AT30TSE752A
		keyword AT30TSE754A
		keyword AT30TSE758A

		abstract
			t This document describes the AT30TSE75XA Linux driver and how to use it.

	middle
		section
			name Introduction
			t
				| #[xref(target="AT30TSE75XA_DS") AT30TSE752A, AT30TSE754A and AT30TSE758A] chips,
				| manufactured by Microchip (former Atmel), are
				| 9- to 12-bit selectable, ±0.5#[+utf °]C accurate digital temperature sensor with nonvolatile
				| registers and Serial EEPROM.
				| The AT30TSE752A integrates 2Kb of EEPROM, AT30TSE754A 4Kb and AT30TSE758A 8Kb.
				| This kernel module doesn't implements the EEPROM functionnality.

		section(anchor="Features")
			name Chip features
			t
				| Here are the main features provided by this type of IC:
			ul
				li Integrated Temperature Sensor + Nonvolatile Registers + Serial EEPROM
				li 2-Wire I2C and SMBus™ compatible serial interface
				li Single 1.7V to 5.5V supply
				li 400kHz and 1MHz compatibility
				li Industry standard green (Pb/Halide-free/RoHS compliant) package options
			t
				| Here are main characteristics of temperature measurement:
			ul
				li Measures temperature from -55C to +125C
				li Highly accurate temperature measurements requiring no external components
				li Pin and software compatible to industry-standard LM75-type devices
				li User-configurable resolution
				li User-configurable high and low temperature limits
				li Nonvolatile registers to retain user-configured or pre-defined power-up defaults
				li Register locking to prevent erroneous misconfiguration
				li Register lockdown for permanent, non-changeable device configuration
				li One-Shot mode for single temperature measurement while in Shutdown mode
				li ALERT output pin for indicating temperature alarms
				li Low power dissipation
				li Shutdown mode to minimize power consumption

		section(anchor="HWMON")
			name Hardware monitoring Subsystem
			t
				| For acquiring temperature the AT30TSE75XA chip, the #[xref(target="HWMON_WEBSITE") hwmon subsystem] present in Linux was used.
				| This subsystems is very simple and lot of builtin applications are available.
		section
			name Kernel module compilation
			t
				| After getting #[xref(target="AT30TSE75XA_SRC") sources] of the driver, simply compile on your machine with the #[tt make] command.
				| You must have #[tt kernel headers] package installed.
		section
			name Kernel module installation
			t
				| As this driver is a I2C device driver, no automatic probing and detection of devices present is possible.
				| You can insert a new device by using I2C framework facilities. Remember, the module name is #[tt at30tse75xa].
				| Here is a simple example on how-to declare a new #[tt at30tse75xa] device at address 0x4c on I2C bus number 9.
				| It assumes the #[tt at30tse75xa] module is loaded into kernel.
			figure
				name Manual at30tse75xa device declaration.
				sourcecode
					| echo "at30tse75xa 0x4c" > /sys/bus/i2c/devices/i2c-9/new_device
		section
			name Testing
			t
				| You can test the device using the #[tt sensor] command this utilities is provided by the lm-sensors pacakge.
				| If the device is properly setup, you may get an output similar to this example:
			figure
				name sensors command output.
				sourcecode
					| at30tse75xa-i2c-9-4c
					| Adapter: i2c-6-mux (chan_id 2)
					| temp1:        +30.6C  (low  = +75.0C, high = +80.0C)
			t
				| The two first lines may change depending on I2C address and configuration.
				| In the example above, the temperature read by the chip is 30.6#[+utf °]C.
		section
			name Debugging
			t Some facilities are included in the driver to perform some debug operations.
			t
				| Some dynamic debug traces are used in important code portions.
				| You can activate these traces by using #[xref(target="DYN_DEBUG") dynamic debug] kernel facilities.
				| For example, you can active the whole module debug by using this command line
			figure
				name Activating dynamic debug for the complete module.
				sourcecode
					| echo 'module at30tse75xa +p' > /sys/kernel/debug/dynamic_debug/control
			t In the example above, we assume #[tt /sys/kernel/debug] is the debugfs mount point.
			t On the contrary, you can disable debug traces by using:
			figure
				name Disabling dynamic debug for the whole module.
				sourcecode
					| echo 'module at30tse75xa -p' > /sys/kernel/debug/dynamic_debug/control
	back
		references
			name References
			references
				name URL References
				reference(anchor='AT30TSE75XA_DS' target='http://ww1.microchip.com/downloads/en/DeviceDoc/Atmel-8854-DTS-AT30TSE752A-754A-758A-Datasheet.pdf')
					front
						title Atmel AT30TSE75XA chip datasheet.
						author
							organization Microchip
				reference(anchor='HWMON_WEBSITE' target='https://www.kernel.org/doc/html/latest/hwmon/index.html')
					front
						title Linux hardware monitoring subsystem.
						author
							organization The Linux Fundation
				reference(anchor='AT30TSE75XA_SRC' target='https://gitlab.cern.ch/apc/controls/sambuca/AT30TSE75XA')
					front
						title AT30TSE75XA kernel module
						author
							organization CERN
				reference(anchor='DYN_DEBUG' target='https://www.kernel.org/doc/html/latest/admin-guide/dynamic-debug-howto.html')
					front
						title Linux kernel dynamic debug how-to.
						author
							organization The Linux Fundation
		section
			name Change Log
			t First version

